//   -----   accueil.cpp   -----   //

#include "accueil.moc"


// Constructeur
KLogin :: KLogin ( ) : KMainWindow ()
{
   // Bouton Ok
   btnOk = new QPushButton ( "OK", this ) ;
   btnOk -> setGeometry ( 300, 20, 55, 25 ) ;
   btnOk -> show ( ) ;

   // Bouton Quitter
   btnQuitter = new QPushButton ( "Quitter", this ) ;
   btnQuitter -> setGeometry ( 300, 50, 55, 25 ) ;
   btnQuitter -> show ( ) ;

   // Label Login
   lblLogin = new QLabel ( "Login : ", this ) ;
   lblLogin -> setGeometry ( 50, 20, 100, 20 ) ;
   lblLogin -> show ( ) ;
   // Label Mot de passe
   lblMdp = new QLabel ( "<font color=black>Mot de Passe : \n<font color=blue><BR><I>facultatif...</I>", this ) ;
   lblMdp -> setGeometry ( 50, 50, 100, 40 ) ;
   lblMdp -> show (  ) ;


   // Label Serveur
   lblServeur = new QLabel ( "Serveur : ", this ) ;
   lblServeur -> setGeometry ( 50, 90, 100, 20 ) ;
   lblServeur -> show (  );

   // Edit Login
   editLogin = new QLineEdit ( this ) ;
   editLogin -> setGeometry ( 170, 20, 100, 20 ) ;
   editLogin -> setFocus (  ) ;
   editLogin -> show ( ) ;

   // Edit Mot de passe
   editMdp = new QLineEdit ( this ) ;
   editMdp -> setGeometry ( 170, 50, 100, 20 ) ;
   editMdp -> setEchoMode ( QLineEdit :: Password ) ;
   editMdp -> show ( ) ;
   QToolTip::add (editMdp , "Le mot de passe n'est ncessaire que pour les joueurs enregistrs ");

   // ComboBox Nom
   comboNom = new QComboBox ( false, this, "Nom des serveurs" ) ;
   comboNom -> setGeometry ( 170, 90, 180, 25 ) ;
   comboNom -> setFocus (  ) ;
   comboNom -> show ( ) ;

   connect ( btnOk, SIGNAL ( clicked ( ) ), this, SLOT ( slotbtnOk ( ) ) ) ;
   connect ( btnQuitter, SIGNAL ( clicked ( ) ), this, SLOT ( slotbtnQuitter ( ) ) ) ;
   connect ( editMdp, SIGNAL ( returnPressed ( ) ), this, SLOT ( slotbtnOk ( ) ) ) ;
   connect ( editLogin, SIGNAL ( returnPressed ( ) ), this, SLOT ( slotMdpFocus ( ) ) ) ;
   connect ( comboNom, SIGNAL ( activated ( int ) ), this, SLOT (slotNomServeur ( int ) ) ) ;

   editLogin->setFocus ( );
}


// ------------------------------------------------------------------------------------------------ //
//			Gestion des vnements
// ------------------------------------------------------------------------------------------------ //

// Fermeture de la fenetre
void KLogin :: closeEvent ( QCloseEvent * )
{
  hide ( ) ;
}

// Ouverture de la fenetre
void KLogin :: showEvent ( QShowEvent * )
{
   remplit();
}

// ------------------------------------------------------------------------------------------------ //
//			METHODE DE LA CLASSE KLogin
// ------------------------------------------------------------------------------------------------ //

// Efface les champs de la fenetre
void KLogin :: efface ( )
{
   editLogin -> setText ( "" ) ;
   editMdp -> setText ( "" ) ;
   editLogin -> setFocus ( ) ;
}

QString KLogin :: getNomServeur ()
{
   QString nom_serveur;

   if (nom_serveurs.size() == 0)
   	return NULL;

   nom_serveur = nom_serveurs [index];

   return nom_serveur ;
}

QString KLogin :: getPort ()
{
   QString port;

   if (ports.size() == 0)
   	return NULL;

   port = ports[index];

   return port ;
}

void KLogin :: remplit ()
{
comboNom -> clear ( ) ;
   nom_serveurs.clear();
   ports.clear();
   QString ligne = "";

   // Lecture du fichier pour remplir la liste des serveurs
   QFile fichier ( "serveurs.txt" ) ;
   if ( ! fichier.open ( IO_ReadOnly ) )
      return ;
   QTextStream ts ( &fichier ) ;
   while ( !fichier.atEnd ( ) )
   {
      ligne = ts.readLine ( ) ;
      nom_serveurs.push_back(ligne) ;
      comboNom -> insertItem ( ligne ) ;
      ligne = ts.readLine ( ) ;
      ports.push_back(ligne) ;
   }
   fichier.close ( ) ;

   index = 0 ;
}

void KLogin :: supprime (vector <QString> & v, uint num)
{
   vector <QString> temp;
   temp = v;
   v.clear();
   int j=0;
   uint i;

   for (i=0; i<temp.size(); i++)
   {
   	if (i != num)
		v[j++]=temp[i];
   }
}



// ------------------------------------------------------------------------------------------------ //
//			SLOT
// ------------------------------------------------------------------------------------------------ //

// Slot pour le bouton Ok
void KLogin :: slotbtnOk ( )
{
   hide ( ) ;
   if (editLogin->text()=="")
   {
      KMessageBox :: information ( this, "Vous devez obligatoirement entrer un login!", "Informations invalides" ) ;
      show();
   }
   else
      emit sigLogue(editLogin->text(), editMdp->text());
}


// Slot pour le bouton Quitter
void KLogin :: slotbtnQuitter ( )
{
   emit sigQuitter ( );
}


// Slot pour le focus du mot de passe
void KLogin :: slotMdpFocus ( )
{
   editMdp->setFocus();
}

void KLogin :: slotNomServeur ( int i )
{
   index = i;
}

void KLogin :: slotRefresh ()
{
   remplit();
}
