//   -----   accueil.h   -----   //

#ifndef _ACCUEIL_H_
#define _ACCUEIL_H_

#include "file.h"
#include <kapp.h>
#include <kmainwindow.h>
#include <kmessagebox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qevent.h>
#include <kmenubar.h>
#include <qnamespace.h>
#include <vector>
#include <qfile.h>
#include <qtooltip.h>
#include <qtextstream.h>

using std::vector;

// Classe KLogin pour la page d'accueil
class KLogin : public KMainWindow
{
   Q_OBJECT
   public :
      KLogin ( ) ;
      void closeEvent ( QCloseEvent * ) ;
      void showEvent ( QShowEvent * ) ;
      void efface ( ) ;
      QString getNomServeur () ;
      QString getPort () ;
      void supprime (vector <QString> &, uint);
      void remplit();
   public slots :
      void slotbtnOk ( ) ;
      void slotbtnQuitter ( ) ;
      void slotMdpFocus ( ) ;
      void slotNomServeur ( int ) ;
      void slotRefresh (); //rafraichit la fenetre de login lorsque l'on rajoute des serveurs
   signals :
      void sigLogue (QString, QString);
      void sigQuitter ();
   private :
      QPushButton *btnOk, *btnQuitter ;
      QLabel *lblLogin, *lblMdp, *lblServeur ;
      QLineEdit *editLogin, *editMdp ;
      QComboBox *comboNom ;
      vector<QString> nom_serveurs;
      vector<QString> ports;
      QString nom_serveur;
      QString port;
      uint index;
} ;

#endif
