//   -----   chat.cpp   -----   //

#include "chat.moc"


// Constructeur
KChat :: KChat ( ) : KMainWindow ( )
{
   // Bouton Ok
   btnEnvoyer = new QPushButton ( "Envoyer", this ) ;
   btnEnvoyer -> setGeometry ( 30, 215, 100, 25 ) ;
   btnEnvoyer -> show ( ) ;

   // Bouton Ok
   btnQuitter = new QPushButton ( "Quitter", this ) ;
   btnQuitter -> setGeometry ( 165, 215, 100, 25 ) ;
   btnQuitter -> show ( ) ;

   // Label Message a envoy
   lblMsg = new QLabel ( "Message : ", this ) ;
   lblMsg -> setGeometry ( 10, 160, 100, 20 ) ;
   lblMsg -> show ( ) ;

   // Edit Message a envoy
   editMsg = new QLineEdit ( this ) ;
   editMsg -> setGeometry ( 120, 185, 170, 20 ) ;
   editMsg -> setFocus (  ) ;
   editMsg -> show ( ) ;

   // TextView Discussion
   dialMsg =new QTextView (this);
   dialMsg -> setGeometry (10, 10, 280, 150);
   dialMsg -> show();

   scrollBar = dialMsg->verticalScrollBar();

   // Combo
   comboDialogue = new QComboBox ( this ) ;
   comboDialogue -> setGeometry ( 10, 185, 100, 25 ) ;

   connect ( btnEnvoyer, SIGNAL ( clicked ( ) ), this, SLOT ( slotBtnEnvoyer ( ) ) ) ;
   connect ( btnQuitter, SIGNAL ( clicked ( ) ), this, SLOT ( slotBtnQuitter ( ) ) ) ;
   connect ( editMsg, SIGNAL ( returnPressed ( ) ), this, SLOT ( slotBtnEnvoyer ( ) ) ) ;
   connect ( comboDialogue, SIGNAL ( activated (const QString & ) ), this, SLOT (slotChangeGamer ( const QString &) ) );

   editMsg -> setFocus();
   nom_dest="";
}


// ------------------------------------------------------------------------------------------------ //
//			Gestion des vnements
// ------------------------------------------------------------------------------------------------ //

// Fermeture de la fenetre
void KChat :: closeEvent ( QCloseEvent * )
{
   hide ( ) ;
}


// ------------------------------------------------------------------------------------------------ //
//			Mthodes de la classe KChat
// ------------------------------------------------------------------------------------------------ //

// Ajoute le nom du joueur
void KChat :: ajouteElement (QString nom)
{
   comboDialogue -> insertItem(nom);
   gamers.push_back(nom);
}


// Efface le champ
void KChat :: efface(int i)
{
   if (i==1)
      dialMsg -> setText("");

   editMsg -> setText("");
   editMsg -> setFocus();
}


// Retire le nom du combobox
void KChat :: enleveElement (QString nom)
{
   int i,nb;

   nb=comboDialogue->count();
   bool trouve=false;

   for (i=0; i<nb && !trouve; i++)
   {
      if (comboDialogue->text(i)==nom)
      {
         trouve=true;
         comboDialogue->removeItem(i);
      }
   }
}


// Ajoute la liste des joueurs dans le combobox
void KChat :: set_gamers(vector<QString> v)
{
   gamers=v;
   comboDialogue->clear();
   for (uint i=0; i<gamers.size(); i++)
   {
      if (gamers[i].left(1)!="/")
         comboDialogue -> insertItem(gamers[i]);
   }
}


// Modifie le nom du combobox
void KChat :: setNom(QString s)
{
   int i=0;
   bool fin=false;
   int nb=comboDialogue->count();

   while (i<nb && !fin)
   {
      if (comboDialogue->text(i)==s)
         fin=true;
      else
         i++;
   }

   if (i<nb)
      comboDialogue->setCurrentItem(i);

   nom_dest=comboDialogue->currentText();
}


// ------------------------------------------------------------------------------------------------ //
//			SLOT
// ------------------------------------------------------------------------------------------------ //

// Slot du bouton Envoyer
void KChat :: slotBtnEnvoyer()
{
   if(editMsg->text() != "")
   {
      QString chaine = QString();

      emit sigEnvoiMsg (editMsg->text(), comboDialogue->currentText());

      if (dialMsg->text()=="")
      {
         dialMsg->setText(dialMsg->text() + "<font color=red><BR><B>" + login + " : </B><I>" + nom_dest + " : " + "</I>" + editMsg->text());
      }
      else
      {
	 dialMsg->setText(dialMsg->text() + "<font color=red><BR><B>" + login + " : </B><I>" + nom_dest + " : " + "</I>" + editMsg->text()+'\n');
      }

      dialMsg->setFocus();

      scrollBar->setMaxValue(scrollBar->maxValue()+1700);
      scrollBar->setValue(scrollBar->maxValue());
      editMsg->setText("");
      editMsg->setFocus();
   }
}


// Slot du bouton Quitter
void KChat :: slotBtnQuitter()
{
   hide ( ) ;
}


// Slot changement de joueur
void KChat :: slotChangeGamer (const QString& g )
{
   nom_dest=g;
}


// Slot pour l'utilisateur logu
void KChat :: slotLogue (QString nom, QString pwd)
{
   login=nom;
}


// Slot du message d'acquittement
void KChat :: slotMsgEnvoye(int i, QString msg, QString nom)
{
   if (i==1)
   {
      dialMsg->setText(dialMsg->text() + "<font color = blue><BR><B>" + nom + " : </B>" + msg.left(msg.length()-1) + "</BR>");
      setNom(nom);
   }
   else if (i==2)
      dialMsg->setText(dialMsg->text() + "<font color = green><BR><B>" + nom + " : </B>" + msg.left(msg.length()-1) + "</BR>");

   show();
   //setFocus();
   scrollBar->setMaxValue(scrollBar->maxValue()+1700);
   scrollBar->setValue(scrollBar->maxValue());
}


// Slot d'une joueur qui part
void KChat :: slotDepartJoueur (QString nom)
{
   if (nom==nom_dest)
      dialMsg->setText (dialMsg->text() + "\n <font color = black><BR><B>" + nom + " vient de se deconnecter</B></BR> \n");

   scrollBar->setMaxValue(scrollBar->maxValue()+1700);
}
