//   -----   chat.h   -----   //

#ifndef _CHAT_H_
#define _CHAT_H_

#include <kapp.h>
#include <kmainwindow.h>
#include <kmessagebox.h>
#include <kmenubar.h>
#include <kpopupmenu.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qtextview.h>
#include <qstring.h>
#include <qcombobox.h>
#include "file.h"
#include "ggs.h"
#include <vector>
#include <qstylesheet.h>
#include <qtextbrowser.h>


// Classe KChat pour le chat
class KChat : public KMainWindow
{
   Q_OBJECT
   public :
      KChat ( ) ;
      void closeEvent ( QCloseEvent * ) ;
      void slotbtnEnvoyer();
      void efface(int);
      void set_gamers(vector<QString>);
      void setNom(QString s);				//modifie le nom sur la combo
      void ajouteElement (QString);
      void enleveElement (QString);
   public slots :
      void slotBtnEnvoyer();
      void slotBtnQuitter();
      void slotMsgEnvoye(int, QString, QString); 	//message d'acquittement que l'on recoit de ggs
      void slotLogue (QString, QString) ; 		// l'utilisateur s'est logue
      void slotChangeGamer (const QString &);
      void slotDepartJoueur (QString);
   signals :
      void sigEnvoiMsg(QString, QString);
   private :
      QPushButton *btnEnvoyer,*btnQuitter ;
      QLabel *lblMsg ;
      QLineEdit *editMsg ;
      QTextView *dialMsg;
      QString login;
      QComboBox *comboDialogue;
      vector<QString> gamers;
      QStyleSheet *style;
      QString nom_dest;
      QScrollBar *scrollBar;
} ;

#endif
