//   -----   ggs.cpp   -----   //

#include "ggs.moc"


// Constructeur
GGS :: GGS ( QString nom_s, short p ) : QSocket ( this )
{

   connect (  this, SIGNAL ( error ( int ) ) , SLOT ( slot_erreur ( ) ) )  ;
   connect (  this, SIGNAL ( hostFound() ) , SLOT ( slot_hoteTrouve ( ) ) )  ;
   connect (  this, SIGNAL ( connected() ) , SLOT ( slot_connecte ( ) ) )  ;
   connect (  this, SIGNAL ( connectionClosed() ) , SLOT ( slot_connectionFermee ( ) ) )  ;
   connect (  this, SIGNAL ( delayedCloseFinished() ) , SLOT ( slot_delaiExpire ( ) ) )  ;
   connect (  this, SIGNAL ( readyRead () ) , SLOT ( slot_lecturePrete ( ) ) )  ;
   connect (  this, SIGNAL ( bytesWritten ( int ) ) , SLOT ( slot_bitsEcrits (int) ) )  ;

   nom_serveur = nom_s ;
   port = p ;
   connectToHost ( nom_serveur, port ) ;
   envoi = new Fifo ( );
   recu = new Fifo ( );
   statut=0;
   resultat="";
   commande="";
   libre=true;
   pthread_mutex_init(&_mutex,NULL);
}


// Destructeur
GGS :: ~GGS ( )
{
   pthread_mutex_destroy(&_mutex);
}


// ------------------------------------------------------------------------------------------------ //
//			Mthodes de la classe GGS
// ------------------------------------------------------------------------------------------------ //

// Ajoute un lment
void GGS :: ajoute(QString s)
{
   envoi->ajoute(s);
}


//
void GGS :: envoi_serveur(QString s)
{
   if(!(envoi->vide()))
   {
      QString chaine = envoi->tete();
      chaine += '\n';
      if ((this->writeBlock (chaine, chaine.length()) == -1))
         perror("erreur lors de l'envoi de donnes\n");

      envoi->supprime();
   }
}


// Gre les messages recus du serveur
void GGS :: gere_message (QString s) //systeme d'erreurs a ameliorer
{

   bool trouve = false; 		//pour le hat, indique si le joueur dont on a recu un message est connecte
   QString nom; 			//contient le nomd e la personne qui nous envoie un message
   QString msg; 			//contient le message que l'on recoit
   int fin_nom;
   int i;
   QString nom_joueur; 			//utilise pour stocker le nom du joueur qui se connete ou se deconnecte
   QString droit_joueur; 		//utilise pour stocker les droits (enregistre iou pas) du jouueur

   if(s.find("ERR Password is incorrect.")!=-1)
   {
      statut--;
      while (!envoi->vide()) envoi->supprime();

      emit sigMessage("Le mot de passe que vous avez saisi est erron.\nVeuillez resaisir votre login et votre mot de passe.");
      emit sigLogin();
   }
   else
   {
      if (s.mid(2,9)=="ERR Login")
      {
         statut--;
         while (!envoi->vide()) envoi->supprime();

	 emit sigMessage("Le login que vous avez entr n'a pas t accept.\nVotre login doit avoir entre 2 et 8 caractres, ne peut commencer par '.' ou '_' et ne peut contenir les carctres ',' et '\'.\nVeuillez resaisir votre login et votre mot de passe.");
	 emit sigLogin();
      }
      else
      {
         if (commande!= "")
         {
            resultat+=s;

            if (s.right(7).mid(0,5)=="READY") 	// c une commande qui se finit par un ack pendant laquelle on n'accepte pas les dialogue
            {
               if (commande =="who")
                  emit sigListe(resultat);
               if (commande=="finger")
                  emit sigRemplitInfos(resultat);
               if (commande=="tell")
                  emit sigMsgEnvoye(0, resultat, NULL);

               commande="";
               resultat="";
            }
         }
         else
	 {
            if (s.find("/os:")!=-1) 		//on ne peut pas faire de commmande /os sinon on bloquerait le chat
            {
               if (s.mid (2,12) == "/os: + match")
                  emit sigJeu(s);   		//pour savoir quand notre partie commence
	       else
		  emit sigJeu(s);		// les autres messages sont utilises dans KJeu
	    }
	 }

         if (s.mid(4,1)=="+" && s.mid(s.mid(4, s.length()-4).find("\n")+5, 5)=="READY" )
         {
            for (i=6; s.mid(i,1)!=" "; i++);

	    nom_joueur = s.mid(6,i-6);
            if (s.mid(i+1, 1)=="1")
               droit_joueur="+";
            else
               droit_joueur="-";

            joueurs.push_back(nom_joueur);

            emit sigAjouteJoueur(nom_joueur, droit_joueur);

         }
	 else if (s.mid(4,1)=="-")
	 {
	    for (i=6; s.mid(i,1)!=" "; i++);

	    nom_joueur=s.mid(6,i-6);
	    emit sigEnleveJoueur(nom_joueur);
	 }
	 else if (s.mid(2,5)==".chat")
	 {
	    fin_nom=s.find(":");
	    nom=s.mid(8, fin_nom-8);
	    msg=s.right(s.length()-(fin_nom+2));
	    msg = msg.left(msg.find("READY"));
	    emit sigMsgEnvoye(2, msg, nom);
	 }
	 else
	 {
	    if (s.left(5)!="READY" && s.find(": +ack:")==-1)
	    {
               fin_nom=s.find(":");
	       nom = s.mid(2,fin_nom-2);
	       if (nom!= "/os")
	       {
		  msg=s.right(s.length()-(fin_nom+2));
		  msg = msg.left(msg.find("READY"));

		  for (uint i=0; i<joueurs.size() && !trouve ; i++)
   		  {
                     if (joueurs[i]==nom)
		        trouve=true;
		  }

		  if (trouve==true)
		     emit sigMsgEnvoye(1, msg, nom);
	       }
            }
         }
      }

      libre=true;
      send("");
      statut++;
   }
}


// Envoie au serveur la chaine passe en argument
bool GGS :: send( QString s)
{
   if (s!="")
      envoi->ajoute(s);
   if (libre==true)
   {
      if (!envoi->vide())
      {
         libre=false;
   	 envoi_serveur(envoi->tete());
      }
      else
	 libre=true;
   }
   return true;
}


// Liste des joueurs
void GGS :: set_joueurs(vector<QString> g)
{
   joueurs=g;
}


// ----------------resultat-------------------------------------------------------------------------------- //
//			SLOT
// ------------------------------------------------------------------------------------------------ //

// Slot nombre de bits crits
void GGS :: slot_bitsEcrits (int nb)
{

}


// Slot on est connect
void GGS :: slot_connecte ( )
{
   emit sigStatus ( "Connection tablie " );
}


// Slot on est dconnect
void GGS :: slot_connectionFermee ( )
{
   emit sigStatus ( "La connection est ferme " );
   emit sigDeco();
}


// Slot timeout
void GGS :: slot_delaiExpire ( )
{
   emit sigStatus ( "Le dlai est expir " );
   emit sigMessage("Impossible de se connecter au serveur.\nVrifiez votre connexion internet et/ou l'adresse du serveur GGS avant de vous reconnecter.");
   emit sigDeco();
}


// Slot d'erreur
void GGS :: slot_erreur ( )
{
   emit sigStatus ("Une erreur s'est produite !");
   emit sigMessage("Impossible de se connecter au serveur.\nVrifiez votre connexion internet et/ou l'adresse du serveur GGS avant de vous reconnecter.");
   emit sigDeco();
}


// Slot on a trouv l'hote
void GGS :: slot_hoteTrouve ( )
{
   emit sigStatus ( "L'hote a t trouv " );
}


// Slot pret pour la lecture
void GGS :: slot_lecturePrete ( )
{
   buf=new char[this->bytesAvailable()+1000];
   memset(buf, '\0', this->bytesAvailable()+1000);
   readBlock(buf, this->bytesAvailable()+1000);

   QString chaine=QString(buf);

   if (chaine.find(": who")!=-1)
      commande="who";
   else if (chaine.find(": finger")!=-1)
      commande="finger";
   else if ((chaine.find(":  tell")!=-1) && (chaine.find("$_")==-1) && chaine.find(": +ack:  tell")==-1)
      commande="tell";

   gere_message(QString(buf));
}
