//   -----   ggs.h   -----   //

#ifndef _GGS_H_
#define _GGS_H_

#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <iostream>
#include <kapp.h>
#include <kmainwindow.h>
#include <qlabel.h>
#include <netdb.h> //pour structure hostent
#include <netinet/in.h> //pour conversions ntons,...
#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <errno.h>
#include <qsocket.h>
#include "file.h"
#include <vector>
#include <pthread.h>
#include <qthread.h>

using std::vector;

// Classe GGS
class GGS : public QSocket
{
   Q_OBJECT
   private :
      QString nom_serveur;
      short port;
      QString nom;
      struct hostent *he; 		//permet de resoudre le nom du serveur en @IP
      struct sockaddr_in addr; 	//structure permettant d'initialiser le socket
      char *buf;			//buffer dans lequel on stocke les messages qu'on recoit du serveur
      QString resultat;
      Fifo *envoi; 			//contient tous les messages que l'on doit envoyer ay serveur
      Fifo *recu; 			//contient tous les messages recus
      int statut; 			//indique le stade de la connexion
      QString commande; 		//contient le nom de la commande dont on recoit le resultat
      bool libre; 			//indique si on peut envoyer ou si il faut attendre
      vector<QString> joueurs;
      pthread_mutex_t _mutex;
      pthread_mutex_t lib;
   public :
      GGS ( ) ;
      GGS ( QString nom_s, short p ) ;	// Constructeur prenant en parametre le nom su serveur et le numero de port
      ~GGS ( );
      void ajoute(QString s);		//permet d'ajouter un element a la liste
      bool send ( QString s ) ;		//ajoute une commande a envoyer a la liste, l'envoi si c possible
      void envoi_serveur (QString s);	//envoi le message au serveur (n'est pas indispensable
      void gere_message (QString s) ;	//traite les erreurs recues et la fin des resultats de commandes
      void set_joueurs(vector<QString> g);
   public slots :
      void slot_hoteTrouve ( ) ;
      void slot_connecte ( ) ;
      void slot_connectionFermee ( ) ;
      void slot_delaiExpire ( ) ;
      void slot_lecturePrete ( ) ;
      void slot_bitsEcrits (int nb) ;
      void slot_erreur ( ) ;
   signals :
      void sigLogin();
      void sigMessage(QString);
      void sigListe(QString);
      void sigAvertir();
      void sigRemplitInfos(QString);
      void sigMsgEnvoye(int, QString, QString);
      void sigJeu(QString); 		//envoi les messages qui concernent le jeu
      void sigAjouteJoueur(QString nom, QString droit);
      void sigEnleveJoueur(QString nom);
      void sigDeco(); //indique qu'on a quitte le serveur
      void sigStatus ( QString );
} ;

#endif
