//   -----   jeu.h   -----   //

#ifndef _JEU_H_
#define _JEU_H_

#include <sys/wait.h>
#include <pthread.h>
#include <signal.h>
#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <vector>

#include <qmessagebox.h>
#include <qpushbutton.h>
#include <qcanvas.h>
#include <qcolor.h>
#include <qpainter.h>
#include <qevent.h>
#include <qlistview.h>
#include <qimage.h>
#include <qlabel.h>

#include <kmessagebox.h>
#include <kapp.h>
#include <kmainwindow.h>
#include <klocale.h>
#include <kstandarddirs.h>


using std::vector;

const int NOIR = 0 ;
const int BLANC = 1 ;
const int CROIX = 2 ;
const int RIEN = 3 ;


// Classe monPion
class monPion
{
   int couleur ;
   public :
      void setCouleur ( int col ) { couleur = col ; }  // Attribut une couleur  un pion
      int getCouleur ( ) { return couleur ; }  // Renvoi la couleur du pion
      QImage dessinePion ( int ) ;   // Dessine un pion
} ;


// Classe KJeu
class KJeu : public KMainWindow
{
   Q_OBJECT
   public :
       KJeu ( ) ;
      ~KJeu ( ) ;
      int getPosition ( int ) ;
      QString getPosColonne ( int ) ;
      int getPosColonne ( QString ) ;
      int getPosLigne ( QString ) ;
      QString getPosLigne ( int ) ;
      void initDamier ( int ) ;
      bool deplacementValide ( int, int, int ) ;
      bool bonneCouleur ( int, int, int, int, int ) ;
      void retournePion ( int, int, int, int, int ) ;
      int nbPions ( int ) ;
      int couleurOppose ( int ) ;
      int validesPositions ( ) ;
      QString getNom ( int ) ;
      void faitCoup ( int, int ,int ) ;
      void valideClick ( int, int, int ) ;
      int positionsValides ( ) ;
      void nouvoCoup ( ) ;
      bool coupLocal ( ) ;
      void setJoueurs(QString l, QString a);
      vector<QString> separe(QString); //separe une chaine en differents elements d'un vecteur
      void closeEvent ( QCloseEvent * ) ;
      void paintEvent ( QPaintEvent * ) ;
      void showEvent ( QShowEvent * );
      void mousePressEvent ( QMouseEvent * ) ;
      int calculeScore ( int ) ;    // Calcule le score
      void majPartie ( QString );
      void set_demande( bool);
      void setTaille ( int t ) { tailleDamier = t ; }
      int getTaille ( ) { return tailleDamier ; }
      void setDemandeEnCours (bool b) { demandeEnCours = b; }
   public slots :
      void slotbtnQuitter ( ) ;
      void slotMsgRecu (QString);
      void slotRepDemande (int, QString);
      void slotAnnule () { annule = true ;}
   signals :
      void sigNouvoCoup ( QString ) ;
      void sigFinPartie ( QString );
      void sigDemande (QString, QString, QString);
      void sigAttente (QString);
   private :
      int pos_x, pos_y ;
      int numCoup ;
      int tailleDamier ;
      int leCoup ;
      bool doitDessiner ;
      monPion **pions ;
      bool **pionsValides ;
      QListView *listCoups ;
      QListViewItem *itemNouvCoup ;
      QPushButton *btnQuitter ;
      QLabel *lblScoreNoir, *lblScoreBlanc, *lblTour ;
      QString login, adv, coups ;
      int maCouleur ;
      bool peuxJouer ;
      QString id_partie;//contient l'id de la partie
      QString id_temp;// contient l'id de la demande
      QString adv_temp;
      QString type_temp;
      bool demande;
      pthread_mutex_t mut;
      bool coup;
      bool demandeEnCours;
      bool partieFinie;
      bool annule; //indique si l'utilisateur a annule sa demande
} ;

#endif
