//   -----   joueurs.cpp   -----   //

#include "joueurs.moc"

// Constructeur
KJoueurs :: KJoueurs ( ) : KMainWindow ( )
{
   listJoueurs =new QListView( this, "Listes des joueurs : ", 0 );
   listJoueurs -> setGeometry ( 0, 0, 290, 300 ) ;
   listJoueurs -> addColumn ( "Personne");
   listJoueurs -> addColumn ( "Statut");
   listJoueurs -> addColumn ( "Innactif");
   listJoueurs -> addColumn ( "En ligne");
   listJoueurs -> show();

   connect ( listJoueurs, SIGNAL ( clicked ( QListViewItem*) ), this, SLOT ( slot_clicked ( QListViewItem*) ) ) ;
   connect ( listJoueurs, SIGNAL ( doubleClicked ( QListViewItem*) ), SLOT ( slot_partie ( QListViewItem*) ) ) ;

   // bouton refresh
   btnRefresh = new QPushButton ( "Rafraichir", this ) ;
   btnRefresh -> setGeometry ( 15, 305, 125, 30 ) ;
   btnRefresh -> show ( ) ;
   connect ( btnRefresh, SIGNAL ( clicked ( ) ), this, SLOT ( slotbtnRefresh ( ) ) ) ;

   // bouton infos
   btnInfos = new QPushButton ( "Informations", this ) ;
   btnInfos -> setGeometry ( 15,335, 125, 30 ) ;
   btnInfos -> show ( ) ;
   connect ( btnInfos, SIGNAL ( clicked ( ) ), this, SLOT ( slotbtnInfos ( ) ) ) ;

   // bouton chat
   btnChat = new QPushButton ( "Chat", this ) ;
   btnChat -> setGeometry ( 155,305, 125, 30 ) ;
   btnChat -> show ( ) ;
   connect ( btnChat, SIGNAL ( clicked ( ) ), this, SLOT ( slotbtnChat ( ) ) ) ;

   // bouton jouer
   btnJouer = new QPushButton ( "Jouer", this ) ;
   btnJouer -> setGeometry ( 155,335, 125, 30 ) ;
   btnJouer -> show ( ) ;
   connect ( btnJouer, SIGNAL ( clicked ( ) ), this, SLOT ( slotbtnJouer ( ) ) ) ;
}

// ------------------------------------------------------------------------------------------------ //
//			Gestion des vnements
// ------------------------------------------------------------------------------------------------ //

// Fermeture de la fenetre
void KJoueurs :: closeEvent ( QCloseEvent * )
{
  hide ( ) ;
}


// ------------------------------------------------------------------------------------------------ //
//			Mthodes de la classe KReversi
// ------------------------------------------------------------------------------------------------ //

// Cache la fentre
void KJoueurs :: cache ( )
{
   hide();
   listJoueurs->clear();
}


// Login
QString KJoueurs :: getLogin ()
{
   if (joueur_sel.login!="")
      return (joueur_sel.login);

   return "";
}


// Ajoute un joueur
void KJoueurs :: ajouteElement(QString nom, QString droit)
{
   QListViewItem *nouveau;
   nouveau = new QListViewItem(listJoueurs,nom, droit);
   listJoueurs -> insertItem ( nouveau ) ;
}


// Enlve un joueur
void KJoueurs :: enleveElement(QString nom)
{
   QListViewItem *nouveau;
   int i,nb;
   bool trouve=false;

   nb = listJoueurs->childCount();
   nouveau = listJoueurs->firstChild();

   for (i=0; i<nb && !trouve; i++)
   {
      if (nouveau->text(0)==nom)
      {
         trouve=true;
	 listJoueurs->takeItem(nouveau);
      }
      nouveau=nouveau->nextSibling();
   }
}



// Renvoie les joueurs
vector<QString> KJoueurs :: getJoueurs()
{
   return pers;
}


// ------------------------------------------------------------------------------------------------ //
//			SLOT
// ------------------------------------------------------------------------------------------------ //

// Slot remplie la liste des joueurs
void KJoueurs :: slotRemplit ( QString s)
{
   joueur_sel.login="";
   joueur_sel.acces="";
   listJoueurs->clear();
   int debut =0;
   int j=0;
   QString car;
   bool termine;		//indique si on a termin la chaine actuelle
   QString *tab = new QString [10];
   int longueur=s.find(": +ack:", -100);	//on cherche la fin de la liste des noms dans les 100 derniers caracteres pour augementer la vitesse

   if (longueur==-1)
   longueur=s.find("READY", -100);

   int i=0;

   QListViewItem *nouveau;			// ligne du listview
   debut=s.find("hostname") + 9 ;		//9 a cause de hostname\n
   pers.clear();
   pers.push_back(".chat");

   while (debut<longueur)
   {
      j=0;
      termine=false;

      while ((car=s.mid(debut,1))!="\n") 	//on s'arrete des qu'il y a un retour a la ligne
      {
         if (car==" ")
	 {
	    if (termine==false)
	    {
	       j++; 				// on passe a la prochaine chaine
	       termine=true; 			//la chaine courante est termine
	    }
	 }
	 else
	 {
	    termine=false;			// la chaine courante n'est pas termine
	    tab[j]+=car; 			// on ajoute le caractere a la chaine courante
	 }
	debut++;
      }

      if (tab[0]!=NULL)
      {
         nouveau = new QListViewItem(listJoueurs,tab[0],tab[1],tab[2],tab[3]);
	 i++;
	 listJoueurs -> insertItem ( nouveau ) ;
	 pers.push_back(tab[0]);
	 tab[0]=tab[1]=tab[2]=tab[3]="";
      }
      debut++;
   }

   emit sigRemplie(pers);
   btnRefresh->setOn(true);
}


// Slot click sur la liste
void KJoueurs :: slot_clicked(QListViewItem* item)
{
   joueur_sel.login=item->text(0);
   joueur_sel.acces=item->text(1);
}


// Slot du bouton rafraichir
void KJoueurs :: slotbtnRefresh ( )
{
   listJoueurs->clear();
   emit sigRefresh();
   btnRefresh->setOn(false);
}


// Slot du bouton informations
void KJoueurs :: slotbtnInfos ()
{
   if (joueur_sel.login!="")
      emit sigJoueur(QString(joueur_sel.login), 1);
}


// Slot du bouton chat
void KJoueurs :: slotbtnChat ()
{
   emit sigJoueur(QString(joueur_sel.login), 2);
}


// Slot du bouton chat
void KJoueurs :: slotbtnJouer ()
{
   emit sigJoueur(QString(joueur_sel.login), 3);
}


// Slot pour la partie
void KJoueurs :: slot_partie ( QListViewItem* item )
{
   joueur_sel.login=item->text(0);
   emit sigJoueur(QString(joueur_sel.login), 3);
}
