//   -----   reversi.h   -----   //

#ifndef _REVERSI_H
#define _REVERSI_H

#include <kapp.h>
#include <kmainwindow.h>
#include <kmessagebox.h>
#include <qmessagebox.h>
#include <kmenubar.h>
#include <kpopupmenu.h>
#include <qworkspace.h>
#include <kstatusbar.h>
#include <qstatusbar.h>
#include <qstring.h>
#include <qlabel.h>
#include <kaction.h>
#include <qtoolbar.h>
#include <ktoolbarbutton.h>
#include <qtoolbutton.h>
#include <qmenubar.h>
#include <qiconset.h>
#include "accueil.h"
#include "joueurs.h"
#include "typepartie.h"
#include "jeu.h"
#include "infos.h"
#include "chat.h"
#include "apropos.h"
#include "demande.h"
#include "nouvserv.h"
#include "supserv.h"
#include "ggs.h"
#include "attente.h"
#include <vector>
#include <qlayout.h>
#include <kstdaccel.h>
#include <kiconloader.h>
#include <kmenubar.h>
#include <kapp.h>
#include <kaction.h>
#include <qnamespace.h>


class KLogin ;
class KJoueurs ;
class KTypePartie ;
class KJeu ;
class KInfos ;
class KChat ;
class KApropos ;
class KDemande ;
class KNouvServ ;
class KSupServ ;
class KAttente ;


// Classe KReversi
class KReversi : public KMainWindow
{
   Q_OBJECT
   public :
      KReversi ( ) ;
      ~KReversi ( ) ;
      void closeEvent ( QCloseEvent * ) ;
      void connexion ( char* nom, short po ) ;
      void statusMsg ( const QString &text ) ;
      KMainWindow * get_mw();
      QString getLogin ();
      QString getAdv();
   public slots :
      void slotpopChangeUti ( ) ;
      void slotpopAjoutServeur ( ) ;
      void slotpopSupServeur ( ) ;
      void slotpopJoueurs ( ) ;
      void slotpopQuitter ( ) ;
      void slotpopApropos ( ) ;
      void slotpopnouvTypePartie ( ) ;
      void slotLogue (QString, QString) ;			//l'utilisateur s'est logue
      void slotLogin ();					//il faut afficher la fenetre de Login
      void slotMessage (QString);				// il faut aafficher un messageBox
      void slotRemplie (vector<QString>);			//indique que la liste d ejoueurs est remplie
      void slotRefresh ();					//met a jour la liste des joueurs connectes
      void slotJoueur (QString, int);				//ouvre les infos sur un joueur
      void slotEnvoiMsg (QString, QString);			//slot que l'on recoit de chat lorsque l'on veut envoyer un message
      void slotNouvoCoup ( QString ) ;
      void slotPartie ( QString, QString, QString, bool ) ;
      void slotAjouteJoueur (QString, QString) ;
      void slotEnleveJoueur (QString) ;
      void slotAjoutServeur ( ) ;
      void slotFinPartie (QString);
      void slotRepDemande (int, QString);
      void slotAttente(QString);
      void slotAnnulerDemande (QString); 			//appele lorsqu'on annule notre demande de match
      void slotDeco() ;
      void slotStatus ( QString s ) { statusMsg(s) ; }
   private :
      int menuLogin, menuPartie ;
      int menuChange, menuJoueurs ;
      GGS *serveur ;
      KLogin *log ;
      KTypePartie *typePartie ;
      KJoueurs *joueurs ;
      KInfos *infos ;
      KChat *chat ;
      KJeu *jeu ;
      KDemande *demande ;
      KSupServ *supServ ;
      KNouvServ *nouvServ;
      KApropos *apropos ;
      QMenuBar *menu ;
      QToolBar *tool ;
      KAttente *attente;
      QPopupMenu *popJeu, *popGgs, *popApropos, *popAide ;
      QImage imUtilisateur, imPartie, imQuitter, imAproposde, imAjouter, imSupprimer, imJoueurs ;
      QPixmap pixUtilisateur, pixPartie, pixQuitter, pixAproposde, pixAjouter, pixSupprimer, pixJoueurs ;
      QToolButton *barUtilisateur, *barPartie, *barQuitter, *barAproposde, *barAjouter, *barSupprimer, *barJoueurs ;
      bool connecte ;
      QString login, mdp, adv;
      KMainWindow *mw;
      bool a_deconnecte;

      QPixmap icon;

} ;

#endif
