//   -----   typepartie.cpp   -----   //

#include "typepartie.moc"

// Constructeur
KTypePartie :: KTypePartie ( ) : KMainWindow ( )
{
    // Label Adversaire
   lblAdv = new QLabel ( "Adversaire : ", this ) ;
   lblAdv -> setGeometry ( 25, 30, 100, 25 ) ;
   lblAdv -> show ( ) ;

   // Label Taille
   lblTaille = new QLabel ( "Taille : ", this ) ;
   lblTaille -> setGeometry ( 25, 65, 100, 25 ) ;
   lblTaille -> show ( ) ;

   // Label Couleur
   lblCouleur = new QLabel ( "Couleur : ", this ) ;
   lblCouleur -> setGeometry ( 25, 100, 100, 25 ) ;
   lblCouleur -> show ( ) ;

   // Label Rated
   lblComptant = new QLabel ( "Comptant : ", this ) ;
   lblComptant -> setGeometry ( 25, 135, 100, 25 ) ;
   lblComptant -> show ( ) ;

   // ComboBox Adversaire
   comboAdv = new QComboBox ( this ) ;
   comboAdv -> setGeometry ( 125, 30, 100, 25 ) ;
   comboAdv -> setFocus (  ) ;
   comboAdv -> show ( ) ;

   // ComboBox pour la taille du jeu
   comboTaille = new QComboBox ( this ) ;
   comboTaille -> setGeometry ( 125, 65, 100, 25 ) ;
   comboTaille -> insertItem ( "4 x 4" ) ;
   comboTaille -> insertItem ( "6 x 6" ) ;
   comboTaille -> insertItem ( "8 x 8" ) ;
   comboTaille -> insertItem ( "10 x 10" ) ;
   comboTaille -> insertItem ( "12 x 12" ) ;
   comboTaille -> insertItem ( "14 x 14" ) ;
   comboTaille -> setCurrentItem ( 2 ) ;
   comboTaille -> show ( ) ;

   // ComboBox pour la couleur
   comboCouleur = new QComboBox ( this ) ;
   comboCouleur -> setGeometry ( 125, 100, 100, 25 ) ;
   comboCouleur -> insertItem ( "Alatoire" ) ;
   comboCouleur -> insertItem ( "Blanc" ) ;
   comboCouleur -> insertItem ( "Noir" ) ;
   comboCouleur -> show ( ) ;

   /// CheckBox pour savoir si la partie sera compte ou non
   checkComptant = new QCheckBox ( this ) ;
   checkComptant -> setGeometry ( 125, 140, 15, 15 ) ;
   checkComptant -> show ( ) ;

   // Bouton Ok
   btnOk = new QPushButton ( "OK", this ) ;
   btnOk -> setGeometry ( 250, 50, 60, 25 ) ;
   btnOk -> show ( ) ;

   // Bouton Annuler
   btnAnnuler = new QPushButton ( "Annuler", this ) ;
   btnAnnuler -> setGeometry ( 250, 80, 60, 25 ) ;
   btnAnnuler -> show ( ) ;

   connect ( btnOk, SIGNAL ( clicked ( ) ), this, SLOT ( slotbtnOk ( ) ) ) ;
   connect ( btnAnnuler, SIGNAL ( clicked ( ) ), this, SLOT ( slotbtnAnnuler ( ) ) ) ;
}


// ------------------------------------------------------------------------------------------------ //
//			Gestion des vnements
// ------------------------------------------------------------------------------------------------ //

// Fermeture de l'application
void KTypePartie :: closeEvent ( QCloseEvent * )
{
  hide ( ) ;
}


// ------------------------------------------------------------------------------------------------ //
//			Mthode de KTypePartie
// ------------------------------------------------------------------------------------------------ //

// Ajoute la liste des joueurs dans le combobox
void KTypePartie :: set_joueurs(vector<QString> g)
{
   joueurs=g;
   comboAdv->clear();
   for (uint i=0; i<joueurs.size(); i++)
   {
      if (joueurs[i].left(1)!="/" && joueurs[i]!=".chat" && joueurs[i]!=login)
         comboAdv -> insertItem(joueurs[i]);
   }
}


// Ajoute un  un chaque lment
void KTypePartie :: ajouteElement (QString nom)
{
   comboAdv -> insertItem(nom);
}


// Enleve un lment
void KTypePartie :: enleveElement (QString nom)
{
   int i,nb;
   nb=comboAdv->count();
   bool trouve=false;

   for (i=0; i<nb && !trouve; i++)
   {
      if (comboAdv->text(i)==nom)
      {
         trouve=true;
	 comboAdv->removeItem(i);
      }
   }
}

void KTypePartie :: setCmbAdv (QString s)
{
   int i=0;
   bool fin=false;
   int nb=comboAdv->count();

   while (i<nb && !fin)
   {
      if (comboAdv->text(i)==s)
         fin=true;
      else
         i++;
   }

   if (i<nb)
      comboAdv->setCurrentItem(i);

}

// ------------------------------------------------------------------------------------------------ //
//			SLOT
// ------------------------------------------------------------------------------------------------ //

// Click sur le bouton Ok
void KTypePartie :: slotbtnOk ( )
{
   // bool ok;
   QString col ;
   QString temp, temp2 ;
   temp = comboTaille -> currentText ( ) ;
   if ( temp.length ( ) < 6 )
      temp2 = temp.left ( 1 ) ;
   else
      temp2 = temp.left ( 2 ) ;

   if ( comboCouleur -> currentItem ( ) == 0 )   // Alatoire
      col = "" ;
   else if ( comboCouleur -> currentItem ( ) == 1 )   // Blanc
     col = "W" ;     // White
   else           // Noir
     col = "B" ;     // Black

   emit sigPartie ( comboAdv -> currentText ( ), temp2, col,checkComptant -> isChecked ( ) ) ;

}


// Bouton Annuler
void KTypePartie :: slotbtnAnnuler ( )
{
   hide ( ) ;
}

